/* eslint-disable no-param-reassign */

/**
 * This Visitor checks if import of `@linaria/react` was renamed and stores that information in state
 */
export default function DetectStyledImportName({
  types: t
}, path, state) {
  if (!t.isLiteral(path.node.source, {
    value: '@linaria/react'
  })) {
    return;
  }

  path.node.specifiers.forEach(specifier => {
    if (!t.isImportSpecifier(specifier)) {
      return;
    }

    const importedName = t.isStringLiteral(specifier.imported) ? specifier.imported.value : specifier.imported.name;

    if (specifier.local.name !== importedName) {
      state.file.metadata.localName = specifier.local.name;
    }
  });
}
//# sourceMappingURL=DetectStyledImportName.js.map